//
//  ViewController.h
//  NG911
//
//  Created by Mason Silber on 9/9/11.
//  Copyright (c) 2011 Columbia University. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreLocation/CoreLocation.h>
#import <QuartzCore/QuartzCore.h>
#import "Message.h"
#import "PJClient.h"
#import "LostClient.h"
#import "QuickResponseViewController.h"
#import "ImgurUploader.h"
#import "LoadingViewController.h"

@interface IMViewController : UIViewController <CLLocationManagerDelegate,UITextViewDelegate,UIActionSheetDelegate,UIImagePickerControllerDelegate,UINavigationControllerDelegate, UITableViewDelegate, UITableViewDataSource, PJClientMessageDelegate, QuickResponseDelegate,ImgurUploaderDelegate>
{
    CLLocationCoordinate2D currentLocationCoordinates;
    NSString *phoneNumber;
    UIView *textView;
    UIButton *send;
    UITextView *messageTextBox;
    BOOL messageHasBeenSent;
    CLLocationManager *locationManager;
    NSMutableArray *messageArray;
    
    //TableView things
    UITableView *messageTable;
    UIBarButtonItem *hideKeyboard;
    UIBarButtonItem *clearConvo;
    UITableViewCell *sendCell;
    UITableViewCell *receiveCell;
    
    PJClient *pjclient;
    NSString *sip_uri;
    int numberOfTimesLocationUpdated;
    
    NSString *imgurURL;
    LoadingViewController *imageSending;
}

@property (nonatomic, retain) NSMutableArray *messageArray;
@property (nonatomic, assign) IBOutlet UITableViewCell *sendCell;
@property (nonatomic, assign) IBOutlet UITableViewCell *receiveCell;

-(void)getPhoto:(id)sender;
//-(void)sendTextLabel:(id)sender;
-(void)hideKeyboard:(id)sender;
-(void)clearConvo:(id)sender;
-(void)about:(id)sender;
-(UILabel *)labelWithDate;
-(NSString *)getFormattedDate;
-(void)sendText:(id)sender;
-(void)createQuickResponse:(id)sender;

// LoST

-(void) initLostRequest;

@end
