//
//  Message.h
//  NG911
//
//  Created by Mason Silber on 9/20/11.
//  Copyright (c) 2011 Columbia University. All rights reserved.
//

//Latest

#import <Foundation/Foundation.h>
#import "PIDF-LO-Client.h"

@interface Message : NSObject
{
    NSString *message;
    NSString *timeStamp;
    NSString *sender;
    UIImage *image;
    BOOL sent;
    NSData *imageData;
    const char *dataString;
    PIDF_LO_Client *PIDFClient;

}

@property (nonatomic, retain) NSString *message;
@property (nonatomic, readonly, retain) NSString *timeStamp;
@property (nonatomic, retain) UIImage *image;
@property (nonatomic, retain) NSString *sender;
@property (nonatomic, retain) NSData *imageData;
@property (nonatomic, retain) PIDF_LO_Client *PIDFClient;
@property const char *dataString;
@property BOOL sent;

-(id)initWithMessage:(NSString *)aMessage;
-(id)initWithImage:(UIImage *)anImage;
-(NSString *)getFormattedDate;
-(BOOL) containsImage;
-(BOOL) containsText;



@end
