//
//  RTTViewController.h
//  NG911
//
//  Created by Mason Silber on 11/28/11.
//  Copyright (c) 2011 Columbia University. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "CoreLocation/CoreLocation.h"
#import "PJClient.h"
#import "LostClient.h"
#import "QuickResponseViewController.h"
#import "AppDelegate.h"

@interface RTTViewController : UIViewController<UITextViewDelegate, UIScrollViewDelegate, CLLocationManagerDelegate, PJClientMessageDelegate, QuickResponseDelegate>
{
    
    UILabel *userTextLabel;
    
    UITextView *callTakerTextView;
    UITextView *userTextView;
    CGSize maxTextViewSize;
    CGSize currentTextViewSize;
    
    CLLocationManager *locationManager;
    CLLocationCoordinate2D currentLocationCoordinates;
    int numberOfTimesLocationUpdated;
    
    PJClient *pjclient;
    NSString *psap_uri;
    
}

@property (nonatomic, retain) UITextView *callTakerTextView, *userTextView;

-(void)hideKeyboard;
-(void)initLostRequest;
-(void)createQuickResponse:(id)sender;

@end
